%{?!_without_python2:%global with_python2 0%{?_with_python2:1} || !(0%{?rhel} >= 8 || 0%{?fedora} >= 30)}
%{?!_without_python3:%global with_python3 0%{?_with_python3:1} || !0%{?rhel} || 0%{?rhel} >= 7}

%global srcname bloom

Name:           python-%{srcname}
Version:        0.11.1
Release:        1%{?dist}
Summary:        Bloom is a release automation tool

License:        BSD
URL:            http://www.ros.org/wiki/bloom
Source0:        https://github.com/ros-infrastructure/%{srcname}/archive/%{version}/%{srcname}-%{version}.tar.gz

BuildArch:      noarch

%description
Bloom provides tools for releasing software on top of a git repository
and leverages tools and patterns from git-buildpackage. Additionally,
bloom leverages meta and build information from catkin
(https://github.com/ros/catkin) to automate release branching and the
generation of platform specific source packages, like debian's src-debs.


%package doc
Summary:        HTML documentation for '%{name}'
BuildRequires:  make
BuildRequires:  python%{python3_pkgversion}-sphinx

%description doc
HTML documentation for the '%{srcname}' python module


%if 0%{?with_python2}
%package -n python2-%{srcname}
Summary:        %{summary}
BuildRequires:  git
BuildRequires:  python2-devel
BuildRequires:  python2-empy
BuildRequires:  python2-nose
BuildRequires:  python2-rosdep >= 0.15.0
BuildRequires:  python2-rosdistro >= 0.8.0
BuildRequires:  python2-setuptools
BuildRequires:  python2-vcstools >= 0.1.22
%{?python_provide:%python_provide python2-bloom}

%if 0%{undefined __pythondist_requires}
Requires:       python2-catkin_pkg >= 0.4.3
Requires:       python2-dateutil
Requires:       python2-empy
Requires:       python2-pyyaml
Requires:       python2-rosdep >= 0.15.0
Requires:       python2-rosdistro >= 0.8.0
Requires:       python2-setuptools
Requires:       python2-vcstools >= 0.1.22
%endif

%if !0%{?rhel} || 0%{?rhel} >= 8
Suggests:       %{name}-doc = %{version}-%{release}
%endif

%description -n python2-%{srcname}
Bloom provides tools for releasing software on top of a git repository
and leverages tools and patterns from git-buildpackage. Additionally,
bloom leverages meta and build information from catkin
(https://github.com/ros/catkin) to automate release branching and the
generation of platform specific source packages, like debian's src-debs.
%endif


%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-%{srcname}
Summary:        %{summary}
BuildRequires:  git
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-empy
BuildRequires:  python%{python3_pkgversion}-nose
BuildRequires:  python%{python3_pkgversion}-rosdep >= 0.15.0
BuildRequires:  python%{python3_pkgversion}-rosdistro >= 0.8.0
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python%{python3_pkgversion}-vcstools >= 0.1.22
%{?python_provide:%python_provide python%{python3_pkgversion}-bloom}

%if %{undefined __pythondist_requires}
Requires:       python%{python3_pkgversion}-catkin_pkg >= 0.4.3
Requires:       python%{python3_pkgversion}-dateutil
Requires:       python%{python3_pkgversion}-empy
Requires:       python%{python3_pkgversion}-PyYAML
Requires:       python%{python3_pkgversion}-rosdep >= 0.15.0
Requires:       python%{python3_pkgversion}-rosdistro >= 0.8.0
Requires:       python%{python3_pkgversion}-setuptools
Requires:       python%{python3_pkgversion}-vcstools >= 0.1.22
%endif

%if !0%{?rhel} || 0%{?rhel} >= 8
Suggests:       %{name}-doc = %{version}-%{release}
%endif

%description -n python%{python3_pkgversion}-%{srcname}
Bloom provides tools for releasing software on top of a git repository
and leverages tools and patterns from git-buildpackage. Additionally,
bloom leverages meta and build information from catkin
(https://github.com/ros/catkin) to automate release branching and the
generation of platform specific source packages, like debian's src-debs.
%endif


%prep
%autosetup -p1 -n %{srcname}-%{version}

# These scripts need a versionless python executable.
# They're only used for the tests - we'll do something else.
rm scripts/*


%build
%if 0%{?with_python2}
%py2_build
%endif

%if 0%{?with_python3}
%py3_build
%endif

%make_build -C docs html man SPHINXBUILD=sphinx-build-%{python3_version}
rm docs/_build/html/.buildinfo


%install
# Make the python2 versions of the binaries the default for now.
# Create versioned symlinks as per python packaging guidelines.
# Also create a fake bindir for each python version for use in tests.

%if 0%{?with_python2}
%py2_install -- --install-scripts %{_bindir}/scripts

echo -n > py2_bins
mkdir py2_bindir
for f in `ls %{buildroot}%{_bindir}/scripts`; do
    mv %{buildroot}%{_bindir}/scripts/$f %{buildroot}%{_bindir}/$f-%{python2_version}
    ln -s $f-%{python2_version} %{buildroot}%{_bindir}/$f-2
    ln -s $f-%{python2_version} %{buildroot}%{_bindir}/$f
    echo -e "%{_bindir}/$f\n%{_bindir}/$f-2\n%{_bindir}/$f-%{python2_version}" >> py2_bins
    ln -s %{buildroot}%{_bindir}/$f-%{python2_version} py2_bindir/$f
done
%endif

%if 0%{?with_python3}
%py3_install -- --install-scripts %{_bindir}/scripts

echo -n > py3_bins
mkdir py3_bindir
for f in `ls %{buildroot}%{_bindir}/scripts`; do
    mv %{buildroot}%{_bindir}/scripts/$f %{buildroot}%{_bindir}/$f-%{python3_version}
    ln -s $f-%{python3_version} %{buildroot}%{_bindir}/$f-3
%if !(0%{?with_python2})
    ln -s $f-%{python3_version} %{buildroot}%{_bindir}/$f
    echo "%{_bindir}/$f" >> py3_bins
%endif
    echo -e "%{_bindir}/$f-3\n%{_bindir}/$f-%{python3_version}" >> py3_bins
    ln -s %{buildroot}%{_bindir}/$f-%{python3_version} py3_bindir/$f
done
%endif

# Scripts don't install the manpage - do it manually.
install -p -m0644 -D docs/_build/man/%{srcname}.1 %{buildroot}%{_mandir}/man1/%{srcname}.1


%check
# Exclude all code format tests and those which require internet access

%if 0%{?with_python2}
PYTHONPATH=%{buildroot}%{python2_sitelib} \
    PATH=$PWD/py2_bindir:$PATH \
    %{__python2} -m nose -w test -e test_code_format
%endif

%if 0%{?with_python3}
PYTHONPATH=%{buildroot}%{python3_sitelib} \
    PATH=$PWD/py3_bindir:$PATH \
    %{__python3} -m nose -w test -e test_code_format
%endif


%files doc
%license LICENSE.txt
%doc docs/_build/html

%if 0%{?with_python2}
%files -n python2-%{srcname} -f py2_bins
%license LICENSE.txt
%doc CHANGELOG.rst README.rst
%{python2_sitelib}/%{srcname}/
%{python2_sitelib}/%{srcname}-%{version}-py%{python2_version}.egg-info/
%{_mandir}/man1/%{srcname}.1.*
%endif

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{srcname} -f py3_bins
%license LICENSE.txt
%doc CHANGELOG.rst README.rst
%{python3_sitelib}/%{srcname}/
%{python3_sitelib}/%{srcname}-%{version}-py%{python3_version}.egg-info/
%{_mandir}/man1/%{srcname}.1.*
%endif


%changelog
* Thu Apr 21 2022 Scott K Logan <logans@cottsay.net> - 0.11.1-1
- Update to 0.11.1 (rhbz#2077274)

* Fri Apr 16 2021 Scott K Logan <logans@cottsay.net. - 0.10.7-1
- Update to 0.10.7 (rhbz#1947254)

* Sat Mar 27 2021 Scott K Logan <logans@cottsay.net> - 0.10.3-1
- Update to 0.10.3

* Thu Mar 11 2021 Scott K Logan <logans@cottsay.net> - 0.10.2-1
- Update to 0.10.2

* Thu Feb 04 2021 Scott K Logan <logans@cottsay.net> - 0.10.1-1
- Update to 0.10.1 (rhbz#1925354)

* Wed Sep 30 2020 Scott K Logan <logans@cottsay.net> - 0.10.0-1
- Update to 0.10.0 (rhbz#1883375)

* Mon Aug 24 2020 Scott K Logan <logans@cottsay.net> - 0.9.8-1
- Update to 0.9.8 (rhbz#1871325)

* Sat May 09 2020 Scott K Logan <logans@cottsay.net> - 0.9.7-1
- Update to 0.9.7 (rhbz#1830030)

* Wed Apr 15 2020 Scott K Logan <logans@cottsay.net> - 0.9.3-1
- Update to 0.9.3 (rhbz#1797911)

* Wed Oct 30 2019 Scott K Logan <logans@cottsay.net> - 0.9.0-1
- Update to 0.9.0 (rhbz#1763368)

* Fri Apr 12 2019 Scott K Logan <logans@cottsay.net> - 0.8.0-1
- Update to 0.8.0 (rhbz#1699490)
- Make doc subpackage a weaker dependency

* Sun Apr 03 2016 Scott K Logan <logans@cottsay.net> - 0.5.21-1
- Update to 0.5.21

* Fri Apr 24 2015 Rich Mattes <richmattes@gmail.com> - 0.5.20-1
- Update to 0.5.20 (rhbz#1214972)

* Wed Mar 04 2015 Rich Mattes <richmattes@gmail.com> - 0.5.19-1
- Update to 0.5.19

* Mon Dec 15 2014 Scott K Logan <logans@cottsay.net> - 0.5.16-1
- Update to 0.5.16

* Sat Dec 13 2014 Scott K Logan <logans@cottsay.net> - 0.5.15-1
- Update to 0.5.15

* Fri Nov 28 2014 Scott K Logan <logans@cottsay.net> - 0.5.14-1
- Update to 0.5.14

* Fri Apr 11 2014 Scott K Logan <logans@cottsay.net> - 0.5.4-1
- Update to 0.5.4
- Removed setuptools patch

* Mon Apr 07 2014 Scott K Logan <logans@cottsay.net> - 0.5.2-1
- Update to 0.5.2
- Changed source URL to Github
- Added HTML to docs
- Added man page
- Added LICENSE.txt
- Added setuptools patch

* Tue Mar 04 2014 Scott K Logan <logans@cottsay.net> - 0.5.1-1
- Initial package
